NiceCRM/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic import RedirectView

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('crm/', include('crm.urls')),
    path('', RedirectView.as_view(url='/crm/', permanent=True)),
    path('summernote/', include('django_summernote.urls')),
]+static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

crm/urls.py
from django.urls import path
from .views import MainPageView, CompanyList, ProjectList, ProjectDetail, InteractionList, InteractionDetail, \
    InteractionCreateForm, InteractionUpdateForm, InteractionDeleteForm, CompanyCreateForm, ProjectCreateForm, \
    ProjectUpdateForm, ProjectDeleteForm, CompanyDeleteForm, CompanyUpdateForm, CompaniesInteractionList, \
    ProjectsInteractionList, UpdateProfile, UserPasswordChangeView

urlpatterns = [
    path('profile/', UpdateProfile.as_view(), name='profile'),
    path('profile/password_change/', UserPasswordChangeView.as_view(), name='password_change'),
    path('interactions/interaction/<int:pk>/delete', InteractionDeleteForm.as_view(), name='delete-interaction'),
    path('interactions/interaction/<int:pk>/update', InteractionUpdateForm.as_view(), name='update-interaction'),
    path('interactions/interaction/<int:pk>/add', InteractionCreateForm.as_view(), name='add-interaction'),
    path('interactions/interaction/<int:pk>', InteractionDetail.as_view(), name='interaction'),
    path('interactions/', InteractionList.as_view(), name='interactions'),
    path('projects/project/add', ProjectCreateForm.as_view(), name='add-project'),
    path('projects/project-interactions/<int:project_id>', ProjectsInteractionList.as_view(), name='project-interaction-list'),
    path('projects/project/<int:pk>/delete', ProjectDeleteForm.as_view(), name='delete-project'),
    path('projects/project/<int:pk>/update', ProjectUpdateForm.as_view(), name='update-project'),
    path('projects/project/<int:pk>', ProjectDetail.as_view(), name='project'),
    path('projects/', ProjectList.as_view(), name='projects'),
    path('companies/company-interactions/<int:company_id>', CompaniesInteractionList.as_view(), name='company-interaction-list'),
    path('companies/company-projects/<int:company_id>', ProjectList.as_view(), name='company-project-list'),
    path('companies/company/<int:pk>/delete', CompanyDeleteForm.as_view(), name='delete-company'),
    path('companies/company/<int:pk>/update', CompanyUpdateForm.as_view(), name='update-company'),
    path('companies/company/add', CompanyCreateForm.as_view(), name='add-company'),
    path('companies/', CompanyList.as_view(), name='companies'),
    path('', MainPageView.as_view(), name='home'),
]

crm/models.py
import PIL
from django.contrib.auth.models import User
from django.core import validators
from django.db import models
from PIL import Image


class Company(models.Model):
    name = models.CharField(
        max_length=64,
        db_index=True,
        verbose_name='Название компании',
        unique='True',
    )

    contact_person = models.CharField(
        max_length=64,
        verbose_name='Полное имя контактного лица',
    )

    short_description = models.CharField(
        max_length=256,
        verbose_name='Короткое описание',
        blank=True,
    )

    adress = models.CharField(
        max_length=128,
        verbose_name='Адресс компании',
        blank=True
    )

    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.name

    class Meta:
        verbose_name_plural = 'Компании'
        verbose_name = 'Компания'
        ordering = ['name']


class Telephone(models.Model):
    number = models.CharField(
        max_length=20,
        db_index=True,
        verbose_name='Телефон',
        help_text='Введите номер телефона',
        validators=[validators.RegexValidator(regex='^[+]*[(]{0,1}[0-9]{1,4}[)]{0,1}[-\s\./0-9]*$')],
    )

    company = models.ForeignKey(
        Company,
        db_index=True,
        verbose_name='Компания',
        on_delete=models.CASCADE
    )

    def __str__(self):
        return self.number

    class Meta:
        verbose_name_plural = 'Телефоны'
        verbose_name = 'Телефон'


class Email(models.Model):
    email = models.EmailField(
        db_index=True,
        verbose_name='Email',
        help_text='Введите email',
        unique=True,
    )
    company = models.ForeignKey(
        Company,
        db_index=True,
        verbose_name='Компания',
        on_delete=models.CASCADE
    )

    def __str__(self):
        return self.email

    class Meta:
        verbose_name_plural = 'Email-ы'
        verbose_name = 'Email'


class Project(models.Model):
    name = models.CharField(
        max_length=64,
        verbose_name='Название проекта',
        unique=True,
        db_index=True,
    )

    description = models.TextField(
        verbose_name='Описание проекта',
        blank=True,
        unique=True,
        max_length=2048
    )

    started_at = models.DateField(
        verbose_name='Дата начала проекта',
        null=False,
    )

    finish_at = models.DateField(
        verbose_name='Дата окончания проекта',
        null=True,
        blank=True,
    )

    cost = models.IntegerField(
        verbose_name='Стоимость проекта',
        null=True,
        blank=True,
        validators=[validators.MinValueValidator(0)]
    )

    company = models.ForeignKey(
        Company,
        verbose_name='Компания заказчик',
        db_index=True,
        on_delete=models.CASCADE
    )

    class Meta:
        verbose_name_plural = 'Проекты'
        verbose_name = 'Проект'
        ordering = ['-started_at']

    def __str__(self):
        return self.name


class Interaction(models.Model):
    project = models.ForeignKey(
        Project,
        verbose_name='Проект',
        db_index=True,
        on_delete=models.CASCADE
    )

    CHANNELS = (
        ('r', 'Заявка'),
        ('l', 'Письмо'),
        ('w', 'Вебсайт'),
        ('i', 'Входящее письмо'),
        ('c', 'Инициатива компании'),
    )

    chanel = models.CharField(
        max_length=1,
        choices=CHANNELS,
        verbose_name='Канал связи',
    )

    description = models.TextField(
        max_length=2048,
        blank=True,
        verbose_name='Описание',
    )

    RATES = (
        ('1', 'Ужастно'),
        ('2', 'Плохо'),
        ('3', 'Нормально'),
        ('4', 'Хорошо'),
        ('5', 'Отлично')
    )
    rate = models.CharField(
        max_length=1,
        choices=RATES,
        blank=True,
        verbose_name='Оценка',
    )

    manager = models.ForeignKey(
        User,
        verbose_name='Менеджер',
        on_delete=models.CASCADE,
    )

    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    class Meta:
        verbose_name_plural = 'Взаимодействия'
        verbose_name = 'Взаимодействие'
        ordering = ['-updated_at']

class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    avatar = models.ImageField()

crm/views.py
from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.models import User
from django.contrib.auth.views import PasswordChangeView
from django.core.cache import cache
from django.core.paginator import Paginator
from django.shortcuts import redirect
from django.urls import reverse, reverse_lazy
from django.views.generic import ListView, DetailView
from django.views.generic.base import TemplateView, ContextMixin
from django.views.generic.edit import DeleteView, CreateView, UpdateView

from .filters import InteractionFilter
from .forms import InteractionForm, CompanyForm, ProjectForm, EmailForm, TelephoneForm, UserForm, ProfileForm
from .models import Company, Project, Interaction, Email, Telephone


class MenuMixin(ContextMixin):
    """ Класс для расширения конекста данными для генерации  в хедере сайта меню

    Наследует:
        ContextMixin - класс джанго для работы с контекстом

    Содержит только один метод который переопределяет ''get_context_data'' родительского класса.
    """

    def get_context_data(self, **kwargs):
        """ Переопределеный метод для добавление в контекст словарей с данными для хедера

        :param kwargs:
        :return:
        """
        context = super().get_context_data(**kwargs)

        # Создание словаря для пунктов топ-меню
        context['menu'] = [
            {'anchor': 'Компании', 'href': reverse('companies'),
             'count': cache.get_or_set('category_count', Company.objects.count(), 60)},
            {'anchor': 'Проекты', 'href': reverse('projects'),
             'count': cache.get_or_set('project_count', Project.objects.count(), 60)},
            {'anchor': 'Взаимодействия', 'href': reverse('interactions'),
             'count': cache.get_or_set('interaction_count', Interaction.objects.count(), 60)}
        ]

        # Создание словаря для пунктов бот-меню
        context['functions'] = [
            {'anchor': 'Добавить Команию', 'href': reverse('add-company')},
            {'anchor': 'Добавить Проект', 'href': reverse('add-project')},
        ]
        return context


class MainPageView(LoginRequiredMixin, MenuMixin, TemplateView):
    """ Класс для обработки запроса главной страницы.

    Наследует:
        LoginRequiredMixin - класс джанго, ограничивающий доступ не авторизированным пользователям
        MenuMixin - написанный класс, для добавления в контекст данные для генерации меню в хедере
        TemplateView - класс джанго, для наследования общих функций и функцию отображения шаблона

    Atributes:
        template_name - переменная содержащая название шаблона для отображения


    """
    template_name = 'crm/home.html'

    def get(self, request, *args, **kwargs):
        """Переопределенный метод обрабатывающий get запрос для получения главной страницы

        При обработке метод учитывает пагинацию, сортировку

        :param request:
        :param args:
        :param kwargs:
        :return:
        """

        # НАЧАЛО проверки номера страницы
        if 'page' in request.GET:
            page_num = self.request.GET['page']
        else:
            page_num = 1

        # Сохранение номера страницы для Paginator при работе с контекстом
        kwargs.update({'page_num': page_num})
        # КОНЕЦ проверки номера страницы

        # НАЧАЛО проверки применения сортировки
        if 'order_by' in request.GET:
            kwargs.update({'order_by': request.GET['order_by']})
        # КОНЕЦ проверки применения сортировки

        context = self.get_context_data(**kwargs)
        return self.render_to_response(context)

    def get_context_data(self, **kwargs):
        """Переопределенный метод для работы с контекстом с учетом пагинации и сортировки


        :param kwargs:
        :return:
        """

        # Словарь допустимых сортировок в формате "название сортировки" : "направление сортировки"
        sort_list = {'sort': 'order_by', 'name': '-name', 'name_rev': 'name', 'created_at': 'created_at',
                     'created_at_rev': '-created_at'}

        context = super().get_context_data(**kwargs)

        context['sort_list'] = sort_list

        # Получаем все компании + телефоны и email
        companies = Company.objects.prefetch_related('email_set', 'telephone_set').all()

        # НАЧАЛО проверка применения сортировки
        if kwargs.get('order_by'):
            context['order_by'] = f"&order_by={kwargs['order_by']}"
            companies = companies.order_by(kwargs['order_by'])
        # КОНЕЦ проверка применения сортировки

        # НАЧАЛО Создание пагинации
        paginator = Paginator(companies, 3, 0)
        page = paginator.get_page(kwargs['page_num'])
        # КОНЕЦ Создание пагинации

        # Добавление в контекст одной определенной страницы
        context['companies'] = page
        # Добавление в контекст общего количества записей
        context['companiesCount'] = companies.count()
        return context


class CompanyList(LoginRequiredMixin, MenuMixin, ListView):
    """Класс для обработки запроса получения списка компаний

    Наследует:
        LoginRequiredMixin - класс джанго, ограничивающий доступ не авторизированным пользователям
        MenuMixin - написанный класс, для добавления в контекст данные для генерации меню в хедере
        ListView - класс джанго, для наследования функций для упращенной работы с списком объектов определенной модели

    Atributes:
        model - указываеться класс модель список объекта которого хотим получить
        context_object_name - указываеться, под каким названием будет храниться список объектов в контексте
        queryset - переменная в которой храниться параметр выборки из БД

    """
    model = Company
    context_object_name = 'companies'
    queryset = Company.objects.prefetch_related('email_set', 'telephone_set')


class CompanyCreateForm(LoginRequiredMixin, MenuMixin, CreateView):
    """Класс для обработки запроса на создании нового объекта модели Company

    Наследует:
        LoginRequiredMixin - класс джанго, ограничивающий доступ не авторизированным пользователям
        MenuMixin - написанный класс, для добавления в контекст данные для генерации меню в хедере
        CreateView - класс джанго, для наследования функций для упращенной работы с формой создания объекта модели

    Atributes:
        template_name - переменная содержащая название шаблона для отображения
        form_class - переменная для хранения класса формы работающая с моделью Company
        success_url - переменная хранящая Url по которой будет совершен редирект при успешном сохранении формы
        email_form - переменная для хранения класса формы работающая с связанной с моделью Company моделью Email
        telephone_form - переменная для хранения класса формы работающая с связанной с моделью Company моделью Telephone
    """
    template_name = 'crm/company_form.html'
    form_class = CompanyForm
    success_url = reverse_lazy('companies')
    email_form = None
    telephone_form = None

    def form_valid(self, form):
        """Переопределении метода валидации формы для учета связанных моделей Telephone и Email

        Валидация считаеться успешной если валидными являються все отправленные формы

        :param form:
        :return:
        """

        # НАЧАЛО Получение из контекста данные отправленных форм связанных моделей
        context = self.get_context_data()
        email_form = context['email_form']
        telephone_form = context['telephone_form']
        # КОНЕЦ Получение из контекста данные отправленных форм связанных моделей

        if email_form.is_valid() and telephone_form.is_valid() and form.is_valid():

            # Сохранение в базе и переменной нового объекта Company
            obj = form.save()

            # НАЧАЛО Сохранение нового обїекта модели Email
            email = self.email_form.save(commit=False)
            email.company = obj
            email.save()
            # КОНЕЦ Сохранение нового объекта модели Email

            # НАЧАЛО Сохранение нового объекта модели Telephone
            telephone = self.telephone_form.save(commit=False)
            telephone.company = obj
            telephone.save()
            # НАЧАЛО Сохранение нового объекта модели Telephone

            messages.success(self.request, 'Компания успешно созданна!')
            return redirect(self.success_url)
        else:
            return self.render_to_response(
                self.get_context_data(form=form, email_form=email_form, telephone_form=telephone_form))

    def get(self, request, *args, **kwargs):
        """Обработка запроса получение страницы создания Компании

        Метод создаёт формы для связанных с моделю Company, моделей Email и Telephone

        :param request:
        :param args:
        :param kwargs:
        :return:
        """
        self.email_form = EmailForm(prefix='email')
        self.telephone_form = TelephoneForm(prefix='telephone')

        return super(CompanyCreateForm, self).get(self, request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        """Обработка запроса создания объекта модели Company и связанных моделей Email и Telephone посредством форм

        Запоминат данные отправленных форм для дальнейшей валидации

        :param request:
        :param args:
        :param kwargs:
        :return:
        """
        self.email_form = EmailForm(request.POST, prefix='email')
        self.telephone_form = TelephoneForm(request.POST, prefix='telephone')

        return super().post(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        """Переопределение метода для работы с контекстом

        Добавляет в контекст объекты формы связанных моделей для отображении их на шаблоне
        Добавляет Текст который будет дополнять тег h1

        :param kwargs:
        :return:
        """
        context = super().get_context_data(**kwargs)
        context['method'] = 'Создать '

crm/templates/crm/company_form.html
{% extends "crm/layouts/basic.html" %}

{% block titel %}
{{ block.super }}|{{ method }}компанию {{ interaction_instance.pk }}
{% endblock %}

{% block content %}
{% load crispy_forms_tags %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    {{ email_form.as_p }}
    {{ telephone_form.as_p }}
    <input type="submit" class="btn btn-success" value="Сохранить">
</form>
<a href="{% url 'companies' %}">Отмена</a>
{% endblock %}

crm/templates/crm/company_list.html
{% extends "crm/layouts/basic.html" %}

{% block titel %}
    {{ block.super }}|Категории
{% endblock %}

{% block content %}
    {% for company in companies %}
        <h3>{{ forloop.counter }}. <a href="{% url 'company-project-list' company.pk %}">{{ company.name }}</a></h3>
        <p><strong>Контакт:</strong> {{ company.contact_person }}</p>
        <p><strong>Краткое описание:</strong> {{ company.short_description|safe }}</span></p>
        <p><strong>Адрес компании: </strong>{{ company.adress }}</p>
        {% for email in company.email_set.all %}
            <p><strong>Почта: </strong>{{ email }}</p>
        {% endfor %}
        {% for telephone in company.telephone_set.all %}
            <p><strong>Телефон:</strong> {{ telephone }}</p>
        {% endfor %}
        <p><strong>Созданно: </strong>{{ company.created_at }} <strong>Обновленно: </strong>{{ company.updated_at }}</p>
        <p>
            <a href="{% url 'update-company' company.pk %}">Изменить компанию</a>
            <a href="{% url 'delete-company' company.pk %}">Удалить компанию</a>
        </p>
        <div>
            <a href="{% url 'company-interaction-list' company.pk %}">Все взаимодействия компании</a>
        </div>
    <hr>
    {% endfor %}
{% endblock %}

crm/templates/crm/delete_form.html
<h3>Вы уверенны что хотите удалить?</h3>
{% load crispy_forms_tags %}
<form method="POST" action="">
    {% csrf_token %}
    <input type="hidden" value="">
    <input type="submit">
    <a href="{{ return }}">Отмена</a>

</form>

crm/templates/crm/home.html
{% extends "crm/layouts/basic.html" %}


{% block titel %}
    {{ block.super }}|Главная
{% endblock %}
{% block content %}
<div>
    <span><strong>Сортировка по:</strong></span>
    <span>Названию </span>
    <a href="{% url 'home' %}?{{ sort_list.sort }}={{ sort_list.name_rev }}">&#8743;</a>
    <a href="{% url 'home' %}?{{ sort_list.sort }}={{ sort_list.name }}">&#8744;</a>
    <span>Дате</span>
    <a href="{% url 'home' %}?{{ sort_list.sort }}={{ sort_list.created_at_rev }}">&#8743;</a>
    <a href="{% url 'home' %}?{{ sort_list.sort }}={{ sort_list.created_at }}">&#8744;</a>
</div>

<hr>
{% for company in companies %}
<h3>{{ companies.start_index|add:forloop.counter0 }}. <a href="{% url 'company-project-list' company.pk %}">{{ company.name }}</a></h3>
<p>Контакт: {{ company.contact_person }}</p>
<p>Краткое описание: {{ company.short_description|safe }}</span></p>
<p>Адрес компании: {{ company.adress }}</p>
{% for email in company.email_set.all %}
    <p>Почта: {{ email }}</p>
{% endfor %}
{% for telephone in company.telephone_set.all %}
    <p>Телефон: {{ telephone }}</p>
{% endfor %}
<p>Созданно: {{ company.created_at|date:"d.m.Y H:i:s" }} Обновленно: {{ company.updated_at|date:"d.m.Y H:i:s" }}</p>
<p>
    <a href="{% url 'update-company' company.pk %}">Изменить компанию</a>
    <a href="{% url 'delete-company' company.pk %}">Удалить компанию</a>
</p>
<hr>
{% endfor %}

<div>
    <div>{{ companies.start_index }} - {{ companies.end_index }} of {{ companiesCount }}</div>
    {% if companies.has_previous %}
    <a href="?page={{ companies.previous_page_number}}{{ order_by }}">&lt;</a>
    &nbsp;&nbsp;|&nbsp;&nbsp;
    {% endif %}
    Часть №{{ companies.number }} из {{ companies.paginator.num_pages }}
    {% if companies.has_next %}
    &nbsp;&nbsp;|&nbsp;&nbsp;
    <a href="?page={{ companies.next_page_number}}{{ order_by }}">&gt;</a>
    {% endif %}
</div>

{% endblock %}

crm/templates/crm/interaction_detail.html
{% extends "crm/layouts/basic.html" %}

{% block titel %}
    {{ block.super }}|{{ page_name }}
{% endblock %}

{% block content %}
    <h3>По проекту:
        <a href="{% url 'project'  interaction.project.pk %}">
            {{ interaction.project.name }}</a>
    </h3>
    <h3>Компания:
        <a href="{% url 'company-project-list'  interaction.project.company.pk %}">
            {{ interaction.project.company.name }}</a>
    </h3>
    <p><strong>Тип зваимодействия: </strong>{{ interaction.get_chanel_display  }}</p>
    <p><strong>Описание: </strong>{{ interaction.description|default:'Нет описания' }}</p>
    <p><strong>Оценка: </strong>{{ interaction.get_rate_display|default:'Нет оценки' }}</p>
    <p><strong>Менеджер: </strong>{{ interaction.manager }}</p>
    <p><strong>Создан: </strong>{{ interaction.created_at }}
        {% if interaction.created_at != interaction.updated_at %}
        <strong>Обновлен: </strong>{{ interaction.updated_at }}
            {% endif %}
    </p>
    <p>
        <a href="{% url 'update-interaction' interaction.pk %}">Отредактировать взаимодействие</a>
        <a href="{% url 'add-interaction' interaction.project.pk %}">Добавить взаимодействие</a>
        <a href="{% url 'delete-interaction' interaction.pk %}">Удалить взаимодействие</a>
    </p>
{% endblock %}

crm/templates/crm/interaction_form.html
{% extends "crm/layouts/basic.html" %}

{% block titel %}
    {{ block.super }}|{{ method }}взаимодействия
{% endblock %}

{% load crispy_forms_tags %}
{% block content %}
    <p>Проект: {{ project.name }}</p>
    <form method="post">
        {% csrf_token %}
        {{ form.as_p}}
        <input type="submit"  value="Сохранить">
    </form>
    <a href="{% url 'project' project.pk %}">Отмена</a>
{% endblock %}

crm/templates/crm/interaction_list.html
{% extends "crm/layouts/basic.html" %}

{% block titel %}
    {{ block.super }}|{{ page_name }}
{% endblock %}


{% block content %}
    {% for interaction in interactions %}
        <div><strong>{{ forloop.counter }}.</strong></div>
        <h3>По проекту:
            <a href="{% url 'project'  interaction.project.pk %}">
                {{ interaction.project.name }}</a>
        </h3>
        <h3>Компания:
            <a href="{% url 'company-project-list'  interaction.project.company.pk %}">
                {{ interaction.project.company.name }}</a>
        </h3>
        <p><strong>Тип зваимодействия: </strong>{{ interaction.get_chanel_display  }}</p>
        <p><strong>Описание: </strong>{{ interaction.description|default:'Нет описания' }}</p>
        <p><strong>Оценка: </strong>{{ interaction.get_rate_display|default:'Нет оценки' }}</p>
        <p><strong>Менеджер: </strong>{{ interaction.manager }}</p>
        <p><strong>Создан: </strong>{{ interaction.created_at }}
            {% if interaction.created_at != interaction.updated_at %}
            <strong>Обновлен: </strong>{{ interaction.updated_at }}
            {% endif %}
        </p>
        <p><a href="{% url 'interaction' interaction.pk %}">Детальнее</a></p>
    <hr>
    {% endfor %}
{% endblock %}

crm/templates/crm/interaction_list_filtred.html
{% extends "crm/layouts/basic.html" %}

{% block titel %}
    {{ block.super }}|{{ page_name }}
{% endblock %}


{% block content %}

    {% if filter %}
    <form method="GET" action="">
        {{ filter.form }}
        <button type="submit">Фильтровать</button>
        <a href="{% url 'interactions' %}">Сброс</a>
    </form>
    {% endif %}

    <hr>

    {% for interaction in filter.qs %}
        <div><strong>{{ forloop.counter }}.</strong></div>
         <h3>По проекту:
        <a href="{% url 'project'  interaction.project.pk %}">
            {{ interaction.project.name }}</a>
    </h3>
    <h3>Компания:
        <a href="{% url 'company-project-list'  interaction.project.company.pk %}">
            {{ interaction.project.company.name }}</a>
    </h3>
    <p><strong>Тип зваимодействия: </strong>{{ interaction.get_chanel_display  }}</p>
    <p><strong>Описание: </strong>{{ interaction.description|default:'Нет описания' }}</p>
    <p><strong>Оценка: </strong>{{ interaction.get_rate_display|default:'Нет оценки' }}</p>
    <p><strong>Менеджер: </strong>{{ interaction.manager }}</p>
    <p><strong>Создан: </strong>{{ interaction.created_at }}
        {% if interaction.created_at != interaction.updated_at %}
        <strong>Обновлен: </strong>{{ interaction.updated_at }}
            {% endif %}
    </p>
        <p><a href="{% url 'interaction' interaction.pk %}">Детальнее</a></p>
    <hr>
    {% endfor %}
{% endblock %}

crm/templates/crm/password_change.html
{% extends "crm/layouts/basic.html" %}

{% block title %}
{{ block.super }}|Изменение пароля пользователя
{% endblock %}

{% block content %}
<h2> Изменение пароля пользователя {{user.username}} </h2>
<form method="post">
{% csrf_token %}
{{ form.as_p }}
<input type="submit" value="Изменить">
</form>
{% endblock %}

crm/templates/crm/project_detail.html
{% extends "crm/layouts/basic.html" %}

{% block titel %}
    {{ block.super }}|{{ page_name }}
{% endblock %}

{% block content %}
        <h3>{{ project.name }}</h3>
        <p>Компания: <a href="{% url 'company-project-list' project.company.pk %}">{{ project.company }}</a></p>
        <p>Описание: {{ project.description|safe }}</span></p>
        <p>Стоимость: {{ project.cost }}</p>
        <p>Начат: {{ project.started_at }} Завершен: {{ project.finish_at|default:'Не завершен' }}</p>
        <p>
            <a href="{% url 'update-project' project.pk %}">Изменить</a>
            <a href="{% url 'add-interaction' project.pk %}">Добавить взаимодействие</a>
            <a href="{% url 'delete-project' project.pk %}">Удалить</a>
        </p>
        <div>
            <hr>
            <h4>Взаимодействия по проекту:</h4>
                {% for interaction in project.interaction_set.all %}
                    <div><strong>{{ forloop.counter }}.</strong></div>
                    <p>Тип зваимодействия: {{ interaction.get_chanel_display }}</p>
                    <p>Описание: {{ interaction.description|default:'Нет описания' }}</p>
                    <p>Оценка: {{ interaction.get_rate_display|default:'Нет оценки' }}</p>
                    <p>Менеджер: {{ interaction.manager }}</p>
                    <p>Начат: {{ interaction.created_at }} Обновлен: {{ interaction.updated_at|default:'Не завершен' }}</p>
                    <br>
                    <p>
                        <a href="{% url 'update-interaction' interaction.pk %}">Отредактировать взаимодействие</a>
                        <a href="{% url 'delete-interaction' interaction.pk %}">Удалить взаимодействие</a>
                    </p>
                    <hr>
                {% endfor %}
        </div>
        <div>
            <h4>Добавить взаимодействие:</h4>
             <form method="post">
                {% csrf_token %}
                {{ form.as_p}}
                <input type="submit"  value="Сохранить">
            </form>
        </div>
{% endblock %}